%global branch 22.08
%global version 22.08.25
%global llvm_major 16
%global llvm_version 16.0.6

# Check for updates with:
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Platform//22.08
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Sdk//22.08
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Sdk.Extension.llvm16//22.08

%ifarch aarch64
%global platform_commit ed55725409eedfe8f0ad506db894755aad74994744f23208120a7fc17745d638
%global sdk_commit 104ca014f9b0554252ceb9f58ee674ba49623898e4399d861fc57a3dbae557cd
%global llvm_commit 37d4c17bc0ac10431175750ffbd307c971d06576e53da50e53809612c1dc3094
%else
# x86_64
%global platform_commit f3a591e25e87b8267afc80f350b1ead04d5627492dc7f4b19e9b8a4903c5673a
%global sdk_commit 7aa6f6dd6dabf9b0c5206749e6e50683444f1a020eb1fee2490122f85cfa6446
%global llvm_commit 24d7a7a0d289ded13b1fd7057f591f625fef0151d169e4b89e82e418b9b57ad3
%endif

Name:           fdo-sdk-%{branch}-flatpak
Summary:        Flatpak Freedesktop SDK
Version:        %{version}
Release:        1
License:        MIT AND Apache-2.0 WITH LLVM-exception
URL:            https://freedesktop-sdk.gitlab.io/

BuildRequires:  flatpak

BuildArch:      aarch64 x86_64 %{ix86}

%description
%{summary}.

%package -n fdo-runtime-%{branch}-flatpak
Summary:        Flatpak Freedesktop Runtime

%description -n fdo-runtime-%{branch}-flatpak
%{summary}.

%package -n fdo-sdk-extension-llvm%{llvm_major}-%{branch}-flatpak
Version:        %{llvm_version}
Summary:        Flatpak Freedesktop SDK llvm%{llvm_major} extension

%description -n fdo-sdk-extension-llvm%{llvm_major}-%{branch}-flatpak
%{summary}.

%prep
flatpak remote-add --user flathub https://dl.flathub.org/repo/flathub.flatpakrepo
flatpak remote-modify --user --collection-id=org.flathub.Stable flathub

%build
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Platform//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{platform_commit} org.freedesktop.Platform//%{branch}
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Sdk//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{sdk_commit} org.freedesktop.Sdk//%{branch}
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Sdk.Extension.llvm%{llvm_major}//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{llvm_commit} org.freedesktop.Sdk.Extension.llvm%{llvm_major}//%{branch}

%install
mkdir -p %{buildroot}%{_datadir}/flatpak-sideload/{fdo-sdk,fdo-runtime,fdo-sdk-extension-llvm%{llvm_major}}-%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-sdk-%{branch} org.freedesktop.Sdk//%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-runtime-%{branch} org.freedesktop.Platform//%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-sdk-extension-llvm%{llvm_major}-%{branch} org.freedesktop.Sdk.Extension.llvm%{llvm_major}//%{branch}

%files
%{_datadir}/flatpak-sideload/fdo-sdk-%branch

%files -n fdo-runtime-%{branch}-flatpak
%{_datadir}/flatpak-sideload/fdo-runtime-%branch

%files -n fdo-sdk-extension-llvm%{llvm_major}-%{branch}-flatpak
%{_datadir}/flatpak-sideload/fdo-sdk-extension-llvm%{llvm_major}-%branch

%changelog
* Mon Jul 15 2024 Hector Martin <marcan@fedoraproject.org> - 22.08.25-1
- Initial release
